VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_detect_leap_year"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4440
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4440
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstLeapYears 
      Height          =   2940
      Index           =   3
      IntegralHeight  =   0   'False
      Left            =   3360
      TabIndex        =   3
      Top             =   120
      Width           =   975
   End
   Begin VB.ListBox lstLeapYears 
      Height          =   2940
      Index           =   2
      IntegralHeight  =   0   'False
      Left            =   2280
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
   Begin VB.ListBox lstLeapYears 
      Height          =   2940
      Index           =   1
      IntegralHeight  =   0   'False
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   975
   End
   Begin VB.ListBox lstLeapYears 
      Height          =   2940
      Index           =   0
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim y As Integer

    For y = 1880 To 2020
        If IsLeapYear0(y) Then lstLeapYears(0).AddItem y
        If IsLeapYear1(y) Then lstLeapYears(1).AddItem y
        If IsLeapYear2(y) Then lstLeapYears(2).AddItem y
        If IsLeapYear3(y) Then lstLeapYears(3).AddItem y
    Next y
End Sub

Public Function IsLeapYear0(ByVal y As Integer) As Boolean
    On Error Resume Next
    IsLeapYear0 = False
    'If the year is evenly divisible by 4 and not by 100, then this
    'is a leap year.
    If y Mod 4 = 0 And y Mod 100 <> 0 Then
        IsLeapYear0 = True
        'If the year is evenly divisible by 4 and 100, then check to
        'see if the quotient of year divided by 100 is also evenly
        'divisible by 4. If it is, then this is a leap year.
    ElseIf y Mod 4 = 0 And y Mod 100 = 0 Then
        If (y \ 100) Mod 4 = 0 Then IsLeapYear0 = True
    End If
End Function
Private Function IsLeapYear1(ByVal y As Integer) As Boolean
    If y Mod 4 <> 0 Then
        IsLeapYear1 = False
    ElseIf y Mod 400 = 0 Then
        IsLeapYear1 = True
    ElseIf y Mod 100 = 0 Then
        IsLeapYear1 = False
    Else
        IsLeapYear1 = True
    End If
End Function

Private Function IsLeapYear2(ByVal y As Integer) As Boolean
    IsLeapYear2 = _
        (y Mod 4 = 0) And _
        ((y Mod 100 <> 0) Or (y Mod 400 = 0))
End Function

Private Function IsLeapYear3(ByVal y As Integer) As Boolean
    IsLeapYear3 = IsDate("2/29/" & y)
End Function

Private Sub Form_Resize()
Dim hgt As Single
Dim i As Integer

    hgt = ScaleHeight - 2 * lstLeapYears(0).Top
    If hgt < 120 Then hgt = 120
    
    For i = 0 To 3
        lstLeapYears(i).Height = hgt
    Next i
End Sub


